package seminar
trait ExprParser extends Parser {
  def variable: Parser[Expr] = word map Variable
  def number: Parser[Expr] = integer map Number
  def factor = number | variable | "(" ~> expr <~ ")"
  def term: Parser[Expr] = (factor ~ (("*" ~ factor | "/" ~ factor)*)) map {
    case (factor, list) => list.foldLeft(factor) {
      case (factor1, ("*", factor2)) => Mul(factor1, factor2)
      case (factor1, ("/", factor2)) => Div(factor1, factor2)
    }
  }

  def expr1: Parser[(Expr, List[(String, Expr)])] = term ~ (("+" ~ term | "-" ~ term)*)

  def expr: Parser[Expr] = expr1 map {
    case (term, list) => list.foldLeft(term) {
      case (term1, ("+", term2)) => Add(term1, term2)
      case (term1, ("-", term2)) => Sub(term1, term2)
    }
  }

}