package seminar
sealed abstract class Result[+T] {
  def map[U](f: T => U): Result[U]
}
case class Success[T](t: T, string: String) extends Result[T] {
  def map[U](f: T => U) = Success(f(t), string)
}
case class Failure[T]() extends Result[T] {
  def map[U](f: T => U) = Failure[U]
}
