package seminar
class StatementParser() extends ExprParser {

  def statement = whileStmt | ifStmt | skip | block | read | write | assignment
  def skip: Parser[Statement] = "skip" ~> ";" map (_ => Skip())
  def assignment: Parser[Statement] = (word <~ "=") ~ (expr <~ ";") map { case (name, expr) => Assignment(name, expr) }
  def whileStmt: Parser[Statement] = ("while" ~> expr) ~ ("do" ~> statement) map {
    case (expr, statement) => While(expr, statement)
  }

  def ifStmt: Parser[Statement] = ("if" ~> expr) ~ ("then" ~> statement) ~ ("else" ~> statement) map {
    case ((expr, statement1), statement2) => If(expr, statement1, statement2)
  }

  def block: Parser[Statement] = "begin" ~> (statement *) <~ "end" map Block
  def read: Parser[Statement] = "read" ~> word <~ ";" map Read
  def write: Parser[Statement] = "write" ~> expr <~ ";" map Write
}